VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3210
   ClientLeft      =   2505
   ClientTop       =   3090
   ClientWidth     =   6390
   Height          =   3615
   Icon            =   "Charsets.frx":0000
   Left            =   2445
   LinkTopic       =   "Form1"
   ScaleHeight     =   3210
   ScaleWidth      =   6390
   Top             =   2745
   Width           =   6510
   Begin VB.ComboBox Combo2 
      Height          =   315
      Left            =   3240
      Sorted          =   -1  'True
      TabIndex        =   3
      Top             =   2520
      Width           =   2295
   End
   Begin VB.TextBox Text1 
      Height          =   2655
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   2
      Top             =   240
      Width           =   2655
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      ItemData        =   "Charsets.frx":000C
      Left            =   3240
      List            =   "Charsets.frx":0042
      TabIndex        =   0
      Top             =   480
      Width           =   2295
   End
   Begin VB.Label Label1 
      BorderStyle     =   1  'Fixed Single
      Height          =   855
      Left            =   3240
      TabIndex        =   1
      Top             =   1080
      Width           =   2775
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
'**************
' Characters Sets (and Fonts) by Chris
'  simple demo of how to set/get FONT character set
'-- Character Sets (Charset) are one of the magical
'-- ingredients for proper display of Internat'l text!
'REQUIRED: Reference to Std Ole Types (any version)
Option Explicit
Option Compare Text ' for combo searching
Private TextObj As Object
Private Sub CharSetDisplay(ByVal cset As Integer)
'refresh routine
'there's a glitch here with VB6?
Dim i&, temp&
temp = Combo1.ListCount - 1
For i = 0 To temp
  If cset = Combo1.ItemData(i) Then
    Combo1.Text = Combo1.List(i)
    Exit Sub
  End If
Next i
'else display value!
Combo1.Text = cset 'not found!?user input!
End Sub

Private Sub FreshFont(ByVal TheFontName As String)
'create new font object
If Trim(TheFontName) = vbNullString Then
  TheFontName = "Arial" ' on most computers!?
'good substitutes:  Times New Roman, Courier New, Tahoma
End If
Dim FontObj As New StdFont
'Set FontObj = TextObj.Font
' if do above, then residual properties
' which may or not want (didn't)
'* Create new/fresh
With FontObj
 .Name = TheFontName
 Combo2.Text = .Name ' did it work?
 .Size = FontSize 'default?
 CharSetDisplay .Charset
End With
Label1.Caption = vbNullString 'clear
Set TextObj.Font = FontObj
Set FontObj = Nothing
End Sub

Private Sub Combo1_Click()
'CHARACTER SET ...verify valid
If Trim(Combo1.Text) = vbNullString Then Exit Sub
Dim i&, temp&
temp = Combo1.ListIndex
If temp = -1 Then 'typed somethin in
 For i = 0 To Combo1.ListCount - 1
  If Combo1.Text = Combo1.List(i) Then
    temp = i
    Exit For
  End If
 Next i
End If
'matched?
If temp <> -1 Then
  Combo1.ListIndex = temp
  temp = Combo1.ItemData(temp)
Else
  temp = Val(Combo1.Text) 'user defined!?
  If temp < 0 Or temp > 255 Then temp = 0 'default
End If
'ole lib code
Dim FontObj As StdFont
Dim NewFontObj As New StdFont
Set FontObj = TextObj.Font
With NewFontObj
  .Name = FontObj.Name
  .Size = FontObj.Size
  .Charset = temp
End With
'supported or valid?
If NewFontObj.Charset <> temp _
 Or NewFontObj.Name <> FontObj.Name Then
'bug in font setup!?... both checks necessary!?
 Label1.Caption = "Character Set [" & Combo1.Text _
 & "] not supported for Font [" _
 & FontObj.Name & "] or Text Object [" _
 & TypeName(TextObj) & "]"
' or not supported by System
 CharSetDisplay FontObj.Charset ' reset/show?
Else
 Set TextObj.Font = NewFontObj
 Label1.Caption = vbNullString 'clear
End If
'clean up
Set FontObj = Nothing
Set NewFontObj = Nothing
End Sub


Private Sub Combo1_KeyPress(KeyAscii As Integer)
If KeyAscii = 13 Then
 If Combo1.ListIndex = -1 Then 'USER INPUT
  Combo1_Click '?
 End If
End If
End Sub


Private Sub Combo2_Click()
' select FONT
If Trim(Combo2.Text) = vbNullString Then Exit Sub
FreshFont Combo2.Text
End Sub


Private Sub Form_Load()
'fill fonts!!This is SLOW w/many fonts -use API?
Caption = "Gathering Fonts..."
Show
Dim temp&, i&
temp = Screen.FontCount - 1
For i = 0 To temp
 Combo2.AddItem Screen.Fonts(i)
Next i
Caption = "Character Sets & Fonts (" & temp & ")"
'*********** -setup prototype-
Set TextObj = Text1
' or any text object like a grid, combo box,
' label, button (with a few mods "txt" vs "cap")
'!! richtextbox is more complex
'!! and doesn't work w/this code!
FreshFont vbNullString 'default
'random text
Dim strng$
For i = 0 To 255
  strng = Chr(i) & strng
Next i
TextObj.Text = strng
'use .Caption if not a std text obj
End Sub


Private Sub Form_Unload(Cancel As Integer)
Set TextObj = Nothing 'clean up
End Sub


